
#include <stdio.h>
#include <string.h>

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>


/* Definimos :
	Longitud maxima del comando
	Palabra de salida: exit
	Funciones de gplink para GP32
*/
#define MAXCOMANDO	512
#define CEXIT		"exit"
#define CHDIR		"cd"		// Cambio de directorio local
#define CHDIRGP		"gcd"		// Cambio de directorio de gp32
#define LSGP32		"gls"		// Listado del directorio
#define GETGP		"gget"		// Descargar archivos de la gp32
#define PUTGP		"gput"		// Subir archivos a la gp32
#define MKDIRGP		"gmkdir"	// Crear directorios en la gp32
#define RMDIRGP		"grmdir"	// Borrar directorios de la gp32
#define RMFILEGP	"grm"		// Borrar archivos de la gp32
#define RUNGP		"grun"		// Ejecutar archivos .fxe o .gxb
#define REBOOTGP	"greboot"	// Reiniciar la gp32
#define ENDGP		"gend"		// Parar el modo pc-link de la consola
#define HELPGP		"help"		// Ayuda del pclink
#define IDSGP		"ids"

char dir_gp32[100]="/";			// Directorio actual de la gp32
char programa[100];			// Ubicacion del programa gplink
char comando_gls[MAXCOMANDO+1];		// Comando para cambiar de directorio si existe

/* Lista todos los archivos del directorio actual de la gp32
   realiza un grep viendo si existe el directorio char *s */
int existe_dir(char *s){ 
	sprintf(comando_gls, "%s gls %s | grep -i %s/",programa,dir_gp32,s);
	if(system(comando_gls))
		return 0;
	else
		return 1;
}

/* Lista todos los archivos del directorio actual de la gp32
   realiza un grep viendo si existe el archivo char *s 
	error conocido: Devuelve 1 si existe un nombre compuesto
	del string de entrada. */
int existe_file(char *s){ 
	sprintf(comando_gls, "%s gls %s | grep -i %s | grep -v /",programa,dir_gp32,s);
	if(system(comando_gls))
		return 0;
	else
		return 1;
}

/* Programa principal */
int main()
{
	char comando[MAXCOMANDO + 1],comando_a_tok[MAXCOMANDO+1]; 	// Comandos introducidos
	char struc[10][20],dir_gp32_new[100],dir_local[100]; 		// Directorios
	int idx=0,x,salida;	// idx: posicion en el vector de directorios
				// salida: codigo de salida de ejecucion de comandos
	char *argumento,*argumento2,*orden,*opcion;
				// argumento: primer argumento
				// argumento2: segundo argumento
				// orden: orden a ejecutar
				// opcion: opcion de las ordenes de gp32
	strcpy(struc[idx],"/");	// Principio de la estructura de gp32

        getcwd(dir_local,40);	// Obtenemos los directorios actuales y del programa gplink
	getcwd(programa,40);
	strcat(programa,"/./gplink");

	while(1){
		getcwd(dir_local,40);	// actualizamos el directorio local
		printf("%s@%s: ", dir_local,dir_gp32);	// imprimimos el prompt

		gets(comando);   	// PROBLEMATICO (violacin de segmento)

		strcpy(comando_a_tok,comando);

		if (strlen(comando) == 0) continue;
		if (strcmp(comando, CEXIT) == 0) exit(1);


		orden = strtok(comando_a_tok," ");

	   	if(strcmp(orden,CHDIR) == 0){	// Cambio de directorio local
			chdir(strtok(NULL," "));
			continue;
		}
		if(strcmp(orden,CHDIRGP) == 0){	// Cambio de directorio de la gp32
			argumento = strtok(NULL, " ");
			if(argumento == NULL){	// Volvemos al inicio
				sprintf(dir_gp32,"/"); 
				idx=0;
				continue;
			}
			if (strcmp(argumento,"..")== 0 && idx!=0){	// Volvemos al path anterior
				strcpy(dir_gp32,"");
				for(x = 0;x !=idx;x++)	strcat(dir_gp32,struc[x]);
				idx--;
				continue;
			}
			if (strncmp(argumento,"/",1)==0){	// Paths absolutos sin implementar
				printf("gpcd: este comando no admite paths absolutos.\n");
				continue;
			}
			if (existe_dir(argumento) && strcmp(argumento,"..")){ // Cabmbio desde el actual
				idx++;
				sprintf(struc[idx],"%s/",argumento);
				strcpy(dir_gp32,"");
				for(x = 0;x !=idx+1;x++) strcat(dir_gp32,struc[x]);
				continue;
			}
			printf("gpcd: error cambiando de directorio.\n");
			continue;
		}
		if(strcmp(orden,LSGP32) == 0){	// listar directorios de gp32
			argumento = strtok(NULL," ");
			if(argumento == NULL){	// lista directorio actual
				sprintf(comando,"%s gls %s",programa, dir_gp32);
				printf("gpls: contenido del directorio: %s\n",dir_gp32);
				system(comando);
				continue;
			}
			if(strcmp(argumento,"-l")==0){	// opcion de gls
				opcion = "-l";
				argumento = strtok(NULL," ");
				if(argumento == NULL){	// lista actual con tamaos
					sprintf(comando,"%s gls %s",programa, dir_gp32);
					printf("gpls: contenido del directorio: %s\n",dir_gp32);
					system(comando);
					continue;
				}
			} else opcion = " ";
			if(strncmp(argumento,"/",1)==0){	// lista path absoluto
				sprintf(comando,"%s gls %s %s",programa,opcion,argumento);
				printf("gpls: contenido del directorio: %s\n",argumento);
				system(comando);
				continue;
			}
			if(strcmp(argumento,"..")==0){	// lista path anterior, no implementado
				printf("Funcion no implementada.\n");
				continue;
			}
			if(existe_dir(argumento) && strcmp(argumento,"..")){ // lista directorio interno
				sprintf(comando,"%s gls %s %s%s",programa,opcion,dir_gp32,argumento);
				printf("Contenido del directorio: %s%s\n",dir_gp32,argumento);
				system(comando);
				continue;
			}
			printf("gpls: error listando directorio.\n");
			continue;
		}
		if(strcmp(orden,GETGP)==0){	// descarga de archivos
			argumento = strtok(NULL," ");
			if(argumento == NULL){ // error: 
				printf("gget: debe especificar el archivo a descargar.\n");
				continue;
			}
			if(strcmp(argumento,"-r")==0){	//descarga recursivamente
				opcion = "-r";
				argumento=strtok(NULL," ");
				if(argumento == NULL){	// descarga toda la SMC
					printf("gget: realizando backup.\ngget: este proceso tardar dependido del contenido.\ngget: Quiere continuar?(y/n)");
					if(getchar()=='n')continue;
					sprintf(comando,"%s gget %s /",programa,opcion);
					system(comando);
					continue;
				}
			}else opcion = " ";
			if(strncmp(argumento,"/",1)==0 && strcmp(opcion,"-r")==0){	// descarga un path absoluto
				sprintf(comando,"%s gget %s %s",programa, opcion, argumento);
				system(comando);
				continue;
			}
			if(existe_file(argumento)){	// descarga un archivo
				sprintf(comando,"%s gget %s %s%s",programa, opcion, dir_gp32, argumento);
				printf("Descargando fichero: %s%s\n",dir_gp32,argumento);
				system(comando);
				continue;
			}
			if(existe_dir(argumento) && strcmp(opcion,"-r")==0){	// descarga un directorio
				sprintf(comando,"%s gget %s %s%s",programa, opcion, dir_gp32, argumento);
				printf("Descargando directorio: %s%s\n",dir_gp32,argumento);
				system(comando);
				continue;
			}else{
				printf("gget: los directorios solo se pueden descargar en modo recursivo -r.\n");
			}				
			printf("gget: error descargando archivos.\n");
			continue;
		}
		if(strcmp(orden,PUTGP)==0){	// Upload de archivos
			argumento = strtok(NULL," ");	
			if(argumento == NULL){	// error:
				printf("gput: debe especificar el origen.\n");
				continue;
			}
			if(strcmp(argumento,"-c")==0){	// opcion de conversion
				opcion = "-c";
				argumento = strtok(NULL," ");
				if(argumento == NULL){	// error:
					printf("gput: debe especificar el origen.\n");
					continue;
				}
			} else opcion = " ";
			argumento2 = strtok(NULL," ");
			if(argumento2 != NULL && strncmp(argumento2,"/",1)==0){  
								// upload path absoluto
				printf("gput: si los directorios no estan creados no se crearn.\n");	
								// modo recursivo sin implementar
				sprintf(comando,"%s gput %s %s %s",programa,opcion,argumento,argumento2);
				system(comando);
				continue;
			}
			sprintf(comando,"%s gput %s %s %s",programa,opcion,argumento,dir_gp32); // upload simple
			system(comando);
			continue;
		}
		if(strcmp(orden,MKDIRGP)==0){	// creacion directorios en gp
			argumento = strtok(NULL," ");
			if(argumento == NULL){	// error:
				printf("gmkdir: debes especificar el nombre del directorio.\n");
				continue;
			}
			if(strncmp(argumento,"/",1)==0){	// crear directorios con path absoluto
				sprintf(comando,"%s gmkdir %s",programa,argumento);
				continue;
			}
			sprintf(comando,"%s gmkdir %s%s",programa,dir_gp32,argumento);
			system(comando);
			continue;
		}
		if(strcmp(orden,RMDIRGP)==0){	// borra directorios en gp
			argumento = strtok(NULL," ");
			if(argumento == NULL){	// error:
				printf("grmdir: debes especificar el nombre del directorio.\n");
				continue;
			}
			if(strncmp(argumento,"/",1)==0){	// borra directorios con path absoluto
				sprintf(comando,"%s grmdir %s",programa,argumento);
				continue;
			}
			if(existe_dir(argumento)){
				sprintf(comando,"%s grmdir %s%s",programa,dir_gp32,argumento);
				system(comando);
				continue;
			}
			printf("grmdir: error borrando el directorio %s.\n",argumento);
			continue;
		}
		if(strcmp(orden,RMFILEGP)==0){	// borra archivos en gp
			argumento = strtok(NULL," ");
			if(argumento == NULL){	// error:
				printf("grm: debes especificar el nombre del archivo.\n");
				continue;
			}
			if(strncmp(argumento,"/",1)==0){	// borrar archivo con path absoluto
				sprintf(comando,"%s grm %s",programa,argumento);
				system(comando);
				continue;
			}
			if(existe_file(argumento)){	// borrar archivo con path actual
				sprintf(comando,"%s grm %s%s",programa,dir_gp32,argumento);
				system(comando);
				continue;
			}
			printf("grm: error borrando el archivo %s.\n",argumento);
			continue;
		}
		if(strcmp(orden,RUNGP)==0){	// ejecuta archivos .fxe .gxb
			printf("grun: este programa requiere pc-link/multi-fw.\n");
			argumento = strtok(NULL," ");
			if(argumento == NULL){	// error:
				printf("grun: debes especificar el nombre del archivo (.gxb o .fxe).\n");
				continue;
			}
			if(strncmp(argumento,"/",1)==0){ // ejecuta con path absoluto
				sprintf(comando,"%s grun %s",programa,argumento);
				system(comando);
				continue;
			}
			if(existe_file(argumento)){	// ejecuta con path relativo
				sprintf(comando,"%s grun %s%s",programa,dir_gp32,argumento);
				system(comando);
				continue;
			}
			printf("grun: error ejecutando el archivo %s.\n",argumento);
			continue;
		}
		if(strcmp(orden,REBOOTGP)==0){	// rebotea la gp32
			printf("greboot: este programa requiere pc-link/multi-fw.\n");
			sprintf(comando,"%s greboot",programa);
			system(comando);
			continue;
		}
		if(strcmp(orden,ENDGP)==0){	// finaliza el modo pc-link de la gp
			printf("gpend: desconectando la gp32.\n");
			continue;
		}
		if(strcmp(orden,HELPGP)==0){	// muestra la ayuda
			sprintf(comando,"%s help",programa);
			system(comando);
			continue;
		}
		if(strcmp(orden,IDSGP)==0){	// ids de la gp32
			sprintf(comando,"%s ids",programa);
			system(comando);
			continue;
		}

		salida = system(comando);	// ejecuta cualquier comando que no sea del gplink

		if(salida!=0){
			printf("msh: error al ejecutar el comando.\n");
		}
	}
        return 0;   
}

